#!/bin/bash
# ===== This test is executed from test.bat ======
#echo on

OneTest() {
#  echo "SO:" $0 "S1:" $1 "S2:" $2 "S3:" $3 "S4:" $4 "S5:" $5 "S6:" $6 "S7:" $7 "S8:" $8 "S9:" $9
  echo ./convert $1 $2 /s $4 $5
  ./convert $1 $2 /s $4 $5
  retVal=$?
  if [ $retVal -ne 0 ]; then
    echo Conversion failure.
    return 1
  fi

  echo ./gcomp $3 $2 /s $6 $7
  ./gcomp $3 $2 /s $6 $7
  retVal=$?
  if [ $retVal -ne 0 ]; then
    echo Compare failure.
    return 2
  fi

return 0
}


MakeTests() {

echo "########### 2 palette image #############"
OneTest "../../images/PEPPER3.bmp" "test_0.bmp" "../../images/PEPPER3.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi
#echo Return value $retVal

OneTest test_0.bmp test_0.ftg ../../images/PEPPER3.bmp "" "" /IDX
#retVal=$?
#if [ $retVal -ne 0 ]; then
#    return $retVal
#fi

OneTest "test_0.bmp" "test_0.gif" "../../images/PEPPER3.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


OneTest "test_0.bmp" "test_0.pcx" "../../images/PEPPER3.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_0.bmp test_0.tga test_0.gif "" "" /IDX
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "test_0.bmp" "test_0.xpm" "test_0.gif"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

echo "########### 4 palette image #############"

./convert ../../images/HEX_Cnt.gif test_1.bmp /PeelFrame 1 /s
retVal=$?
if [ $retVal -ne 0 ]; then
    return 1
fi

OneTest "test_1.bmp" "test_1.gif" "test_1.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "test_1.gif" "test_1.txt" "test_1.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "test_1.gif" "test_1.xpm" "test_1.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

echo "########### 16 palette image #############"

./convert ../../images/VGALOGO.rle test_7.bmp /s
retVal=$?
if [ $retVal -ne 0 ]; then
    return 1
fi

OneTest "../../images/VGALOGO.rle" "test_7.ftg" "test_7.bmp"
#retVal=$?
#if [ $retVal -ne 0 ]; then
#    return $retVal
#fi

OneTest "../../images/VGALOGO.rle" "test_7.gif" "test_7.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "../../images/VGALOGO.rle" "test_7.pcx" "test_7.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "../../images/VGALOGO.rle" "test_7.txt" "test_7.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest "../../images/VGALOGO.rle" "test_7.xpm" "test_7.bmp"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "########### 256 palette image #############"

OneTest ../../images/assist.gif test_6.bmp ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_6.bmp test_6.ftg ../../images/assist.gif
#retVal=$?
#if [ $retVal -ne 0 ]; then
#    return $retVal
#fi

OneTest test_6.bmp test_6.gif ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_6.gif test_6.pcx ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_6.gif test_6.ps ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_6.pcx test_6.tga ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

#convert /Format txt#gm ../../images/assist.gif test_6.txt /s
#@if errorlevel 1 goto errorc
#gcomp ../../images/assist.gif test_6.txt /s
#@if errorlevel 1 goto error

OneTest test_6.tga test_6.xpm ../../images/assist.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "########### 2 levels monochrome image #############"

./convert ../../images/lynne.pcx test_2.art /PeelPlane 7 /s
retVal=$?
if [ $retVal -ne 0 ]; then
    return 1
fi

OneTest ../../images/lynne.pcx test_2.bmp test_2.art /PeelPlane 7
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.csv test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.ftg test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.gif test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.oko test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.pcx test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.ps test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.ras test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_b.ras test_2.bmp /Format "ras#SUN"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.tga test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2a.txt test_2.bmp /Format "txt#plain"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2b.txt test_2.bmp /Format "txt#gm"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_2.art test_2.xpm test_2.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "########### 256 levels gray image #############"

OneTest ../../images/lynne.pcx test_.bmp ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lynne.pcx test_.csv ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

#OneTest ../../images/lynne.pcx test_.ftg ../../images/lynne.pcx
#retVal=$?
#if [ $retVal -ne 0 ]; then
#    return $retVal
#fi

OneTest ../../images/lynne.pcx test_.fts ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lynne.pcx test_.gif ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lynne.pcx test_.mat ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lynne.pcx test_.oko ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_.pcx ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_.ps ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_b.ras ../../images/lynne.pcx /Format "ras#SUN"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_.ras ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_.tga ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_a.txt ../../images/lynne.pcx /Format "txt#plain"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_b.txt ../../images/lynne.pcx /Format "txt#gm"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_.mat test_.xpm ../../images/lynne.pcx
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


@echo "########### 65536 levels gray image #############"

OneTest ../../images/lenaI16.mat test_3.bmp ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lenaI16.mat test_3.csv ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/lenaI16.mat test_3.ftg ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


OneTest ../../images/lenaI16.mat test_3.fts ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


OneTest test_3.fts test_3.mat ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_3.fts test_3.oko ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_3.fts test_3a.txt ../../images/lenaI16.mat /Format "txt#plain"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_3.fts test_3b.txt ../../images/lenaI16.mat /Format "txt#gm"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_3.fts test_3.xpm ../../images/lenaI16.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "########### RGB 16 bit color image #############"

OneTest ../../images/input_16.tga test_8.bmp ../../images/input_16.tga
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_8.bmp test_8.bmp ../../images/input_16.tga
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "########### RGB 24 bit color image #############"

OneTest ../../images/i24.bmp test_4.bmp ../../images/i24.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


OneTest test_4.bmp test_4.ftg ../../images/i24.bmp
#retVal=$?
#if [ $retVal -ne 0 ]; then
#    return $retVal
#fi

OneTest test_4.bmp test_4.mat ../../images/i24.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_4.mat test_4.pcx ../../images/i24.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_4.pcx test_4.eps ../../images/i24.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

#convert test_4.bmp test_4.fts /s
#@if errorlevel 1 goto errorc
#gcomp test_4.bmp test_4.fts /s
#@if errorlevel 1 goto error


OneTest test_4.pcx test_4a.ras ../../images/i24.bmp /Format "ras#topoL"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_4.pcx test_4b.ras ../../images/i24.bmp /Format "ras#SUN"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_4b.ras test_4.tga ../../images/i24.bmp
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_4.tga test_4.txt ../../images/i24.bmp /Format "txt#gm"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "############# Doubles ###################"
# Real value named "double" is supported with formats FTS and MAT
# Formats CSV and TXT(plain) can also store double with lower precision.

OneTest ../../images/double.mat test_5.csv ../../images/double.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/double.mat test_5.fts ../../images/double.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_5.fts test_5.mat ../../images/double.mat
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest test_5.fts test_5.txt ../../images/double.mat /Format "txt#plain"
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


echo "############# Multiple frames ###################"

OneTest ../../images/HEX_Cnt.gif test_9.bmp ../../images/HEX_Cnt.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

OneTest ../../images/HEX_Cnt.gif test_9.gif ../../images/HEX_Cnt.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi

#@rem Gray only
#@rem convert ../../images/HEX_Cnt.gif test_9.mat /s
#@rem @if errorlevel 1 goto errorc
#@rem gcomp test_9.bmp test_9.mat /s
#@rem @if errorlevel 1 goto error

OneTest test_9.gif test_9.tga ../../images/HEX_Cnt.gif
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


OneTest test_9.gif test_9.txt ../../images/HEX_Cnt.gif /format txt#gm
retVal=$?
if [ $retVal -ne 0 ]; then
    return $retVal
fi


return 0
}


if test -d bin/generic ; then
  #echo "Didectory exists."
  cd bin/generic
  pwd
  MakeTests
  retVal=$?
  #echo $retVal
  case $retVal in
    0) rm test_*.*
       rm core
       echo "############# END OF TESTS ###################";;
    1) echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       echo "Convert of image has been failed"
       echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";;
    2) echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
       echo " Image compare has been failed"
       echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";;
    *) echo "Unknown return code";;
  esac

  pwd
  cd ../../
fi



#echo off
echo "###############################################"


